<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The following parameters are used to compute the nutrients provided by the previous crop.</translate>
          </q-banner>

          <q-card-section>
            <div>
              <div class="text-grey-8 q-mb-xs">
                <translate>Was there a main crop in the previous season?</translate>
              </div>

              <q-btn-toggle
                v-model="storePreviousCropExists"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>

            <q-select
              v-if="storePreviousCropExists"
              v-model="storePreviousCropProfile"
              :options="sortedPreviousCropOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Crop profile from the previous campaign')"
              @update:model-value="onPreviousCropProfileChange"
              class="q-mt-md"
            />
            <q-select
              v-if="storePreviousCropExists && hasPreviousCropAerialPartDestinations"
              v-model="storePreviousCropAerialPartDestination"
              :options="previousCropAerialPartDestinationOptions"
              option-value="part_aer_id"
              :option-label="getRequafertiI18NFieldName('libelle_part')"
              filled
              :loading="isLoading"
              :label="$gettext('Destination of the aerial part of the crop')"
              class="q-mt-md"
            />

            <div
              v-if="soilSampleExists && storePreviousCropExists && storePreviousCropProfile"
              class="q-mt-md"
            >
              <div class="text-grey-8 q-mb-xs">
                <translate>Was the effect of the previous main crop on nitrogen supply already taken into account in the soil analysis?</translate>
              </div>

              <q-btn-toggle
                v-model="storePreviousCropTestSampleIncludesNitrogenEffect"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import queryRequafertiConfig from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiConfig'

export default {
  name: 'RequafertiPreviousCropProfilePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, RequafertiI18nMixin],
  data () {
    return {
      requafertiConfig: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Previous crop')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    canContinue () {
      return this.isParameterSet(this.storePreviousCropExists) &&
        (!this.storePreviousCropExists || (this.isParameterSet(this.storePreviousCropProfile) &&
        (!this.hasPreviousCropAerialPartDestinations || this.isParameterSet(this.storePreviousCropAerialPartDestination)) &&
        (!this.soilSampleExists || this.isParameterSet(this.storePreviousCropTestSampleIncludesNitrogenEffect))))
    },
    isLoading () {
      return !this.requafertiConfig
    },
    previousCropOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['culture_effet_prec'] || []
    },
    sortedPreviousCropOptions () {
      return [...this.previousCropOptions].sort((a, b) => a.libelle.localeCompare(b.libelle))
    },
    previousCropAerialPartDestinationCombinations () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['effet_prec']
    },
    previousCropAerialPartDestinationOptions () {
      if (!this.storePreviousCropProfile || !this.previousCropAerialPartDestinationCombinations) {
        return []
      } else {
        return this.previousCropAerialPartDestinationCombinations.filter(part => part.type_cult_id === this.storePreviousCropProfile.id)
      }
    },
    hasPreviousCropAerialPartDestinations () {
      return this.previousCropAerialPartDestinationOptions?.length > 0
    },
    soilSampleExists () {
      return this.$store.state.fertilizationPlan.parameters.soilSampleExists
    },
    storePreviousCropExists: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.previousCropExists
      },
      set (v) {
        this.updateParameter('previousCropExists', v)
      }
    },
    storePreviousCropProfile: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.previousCropProfile
      },
      set (v) {
        this.updateParameter('previousCropProfile', v)
      }
    },
    storePreviousCropAerialPartDestination: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.previousCropAerialPartDestination
      },
      set (v) {
        this.updateParameter('previousCropAerialPartDestination', v)
      }
    },
    storePreviousCropTestSampleIncludesNitrogenEffect: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.previousCropTestSampleIncludesNitrogenEffect
      },
      set (v) {
        this.updateParameter('previousCropTestSampleIncludesNitrogenEffect', v)
      }
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadConfig('cache-first')

    // if there is no soil sample
    if (!this.soilSampleExists) {
      this.storePreviousCropTestSampleIncludesNitrogenEffect = null
    }

    // Refresh online data (do not wait until completion)
    this.loadConfig('network-only')
  },
  methods: {
    onClickNext () {
      // reset linked fields when no intermediate crop
      if (!this.storePreviousCropExists) {
        this.storePreviousCropProfile = null
        this.storePreviousCropAerialPartDestination = null
        this.storePreviousCropTestSampleIncludesNitrogenEffect = null
      }
      this.$router.replace({
        name: 'requafertiIntermediateCropProfile'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiSoil'
      })
    },
    onPreviousCropProfileChange () {
      // reset fields depending on selected crop when it changes
      this.storePreviousCropAerialPartDestination = null
      if (this.previousCropAerialPartDestinationOptions?.length === 1) {
        this.storePreviousCropAerialPartDestination = this.previousCropAerialPartDestinationOptions[0]
      }
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryRequafertiConfig,
        fetchPolicy
      })
      this.requafertiConfig = data?.requaferti__config
    }
  }
}
</script>
